// half lambert per pixel lighting

varying vec3 position;
varying vec3 normal;

uniform sampler2D tex0;
uniform int use_tex0;

void main (void)
{
 vec4 color = vec4( 1, 1, 1, 1 );
 float alpha = 1.f;
 if (use_tex0!=0) {
  color = texture2DProj( tex0, gl_TexCoord[0] );
  alpha = color.a;
 }

 vec3 eye     = vec3( 0, 0, 100 );
 vec3 light    = normalize( gl_LightSource[0].position.xyz );
 normal = normalize( normal );

 float diffuse = dot( light, normal ) * 0.5f + 0.5f;
 diffuse = diffuse*diffuse;
	
 vec3 halfv     = reflect( -light, normal );
 float specular = pow( max( dot( normal, halfv ), 0.0 ), gl_FrontMaterial.shininess );

 gl_FragColor = gl_FrontMaterial.emission * color
                   + gl_LightSource[0].ambient * gl_FrontMaterial.ambient * color
                   + gl_LightSource[0].diffuse   * gl_FrontMaterial.diffuse   * diffuse * color
                   + gl_LightSource[0].specular * gl_FrontMaterial.specular * specular;

 gl_FragColor.a = alpha;
}
